/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.egreso;

import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.tipo_egreso.TipoEgreso;
import java.util.Objects;

public class Egreso {

  private int id;
  private String nro;
  private String descripcion;
  private int valor;
  private TipoEgreso tipoEgreso;
  private Caja caja;

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getNro() {
    return nro;
  }

  public void setNro(String nro) {
    this.nro = nro;
  }

  public String getDescripcion() {
    return descripcion;
  }

  public void setDescripcion(String descripcion) {
    this.descripcion = descripcion;
  }

  public int getValor() {
    return valor;
  }

  public void setValor(int valor) {
    this.valor = valor;
  }

  public TipoEgreso getTipoEgreso() {
    return tipoEgreso;
  }

  public void setTipoEgreso(TipoEgreso tipoEgreso) {
    this.tipoEgreso = tipoEgreso;
  }

  public Caja getCaja() {
    return caja;
  }

  public void setCaja(Caja caja) {
    this.caja = caja;
  }

  @Override
  public String
  toString() {
    return "Egreso{" +
        "id=" + id +
        ", nro='" + nro + '\'' +
        ", descripcion='" + descripcion + '\'' +
        ", valor=" + valor +
        ", tipoEgreso=" + tipoEgreso +
        ", caja=" + caja +
        '}';
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof Egreso)) {
      return false;
    }
    Egreso egreso = (Egreso) o;
    return id == egreso.id &&
        valor == egreso.valor &&
        Objects.equals(nro, egreso.nro) &&
        Objects.equals(descripcion, egreso.descripcion) &&
        Objects.equals(tipoEgreso, egreso.tipoEgreso) &&
        Objects.equals(caja, egreso.caja);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, nro, descripcion, valor, tipoEgreso, caja);
  }
}
